#-*- coding:utf-8 -*-
"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""

import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')
sys.path.insert(0, 'C:\\Python\\lib')

__script__ = "PyShopper"
__version__ = '0.01(3)'
__author__ = 'masa'
__web__ = 'http://masaland.cocolog-nifty.com/'
__Copyright__ = ' Copyright (c) 2009-2014 masa'

import e32db
import e32
import os
import appuifw
import re
import dir_iter
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow

appuifw2_exist = 0
try:
    import appuifw2
    #appuifw = appuifw2
    appuifw2_exist = 1
except ImportError:
    #pass
    appuifw2_exist = 0

try:
    from PyFbuiutil import Fbrowser
    from PyFbuiutil import Getpath
    Err_exit = 0
except:
    rtn = appuifw.query(unicode("Please install PyFbuiutl.py"), "query")
#    sys.exit(0)
    Err_exit = 1

###############  Please change according to your environment.
ini_path = 'E:\\ブリーフケース\\dbdata\\'
pdb_file = 'E:\\ブリーフケース\\dbdata\\PyShopper.pdb'
log_file = 'E:\\ブリーフケース\\dbdata\\PyShopper.log' #error log file
Default_path = 'E:\\ブリーフケース\\dbdata\\'
LS       = 0  # Language   1=English  0=Japanese
Jump_range = 4 #Jump range (Right/Left Arrow key)
#
category = [['0 : 野菜',       '0 : Vegetables'],
            ['1 : 魚肉乳製品', '1 : Fish/Meet/etc'],
            ['2 : その他食品', '2 : Misc.foods'],
            ['3 : 総菜',       '3 : OtherDishes'],
            ['4 : 調味料',     '4 : Condiment'],
            ['5 : 飲み物',     '5 : Beverage'],
            ['6 : お菓子類',   '6 : Cake/Sweets'],
            ['7 : その他',     '7 : Otehrs']
       # カテゴリを追加する場合は、以下の行の先頭の＃をはずして
       # 必要な内容に修正する。さらに追加したい場合は同じフォーマットで
       # 追加する。先頭の数字は2桁までがサポート範囲
#            ,['8 : ダミー１',   '8 : Otehrs1']
#            ,['9 : ダミー２',   '9 : Otehrs2']
#            ,['10 : ダミー３',  '10 : Otehrs3']
#            ,['11 : ダミー４',  '11 : Otehrs4']
           ]

# other global variables
type_list   = []
mark_list   = []
type_list_u = []
mark_list_u = []
type_list_p = []
mark_list_p = []
type_all    = 0
mark_all    = 0
###############


# key word in each language-----------------------
menu_exit      = ['終了','Exit']
menu_wordnext  = ['文字検索','Search word']
menu_about     = ['情報','About']
menu_back      = ['戻る','Back']
menu_item      = ['アイテム','Item']
menu_open      = ['品名編集','Edit Item name']
menu_save      = ['完了','Done']
menu_new       = ['アイテム新規作成','New Item']
menu_delete    = ['アイテム削除','Delete Item']
menu_editcan   = ['編集のキャンセル','Cancel changes']
menu_file      = ['ファイル','File']
menu_import    = ['csv インポート','Import csv']
menu_export    = ['csv エクスポート','Export csv']
menu_compact   = ['ファイル compact','File compact']
menu_list      = ['リスト','List']
menu_listtm    = ['カテゴリ、マーク選択','category/Mark for list']
menu_edittm    = ['アイテム編集','Edit Item']
menu_back2list = ['リストに戻る','back to list']
menu_alllist   = ['全リストに戻る','back (all list)']
menu_details   = ['アイテム詳細','Details']
msg_inprocess  = ['処理中です... \n','processing... \n']
msg_inputword  = ['検索文字（１部分可）','Search word\n (Partial allowed)']
msg_noword     = ['文字／アイテムが見あたりません','No such word or Item']
msg_searchword = ['検索文字: ','Search word: ']
msg_example    = ['食パン','Bread']
msg_nofile     = [' ファイルがありません\n','File not exist\n']
msg_makefile   = [' 新規ファイルを作成します\n','make new file\n']
msg_convert    = ['csv ファイルから新ファイルへ変換します\n旧データは削除されます\nよろしいですか',
		  'Import csv_file to new file\n old data will delete\n  OK ?']
msg_overwr     = ['上書きしますか？', 'Allow overwrite ?']
msg_csverror   = ['csv ファイルにエラーがあります\nログファイルを見てください',
                         'error detected in csv file \n please see log file']
msg_ioerror    = ['ファイル入出力でエラーがありました','Input/Output file error']
msg_cancel     = ['キャンセルされました','Canceled']
msg_filename   = ['ファイル名','File name']
msg_select     = ['選択','select']
msg_exfile     = ['新規テキスト.csv','new_text.csv']
item_id        = ['Id# 　','Id#  ']
item_mark      = ['完了　','Mark']
item_type      = ['カテゴリ','categry']
item_note      = ['アイテム','Item']
item_ndone     = ['v : 購入必要','v : not done']
item_done      = ['_ : 完了',    '_ : done']
item_alltype   = ['すべてのカテゴリ','all categry']
item_allmark   = ['すべてのマーク','all Mark']
#---------------------------------------------------------------------

def confread():
  global pdb_file
  global log_file
  global LS
  global Default_path
  global category
  global Jump_range

  try:
    ini_file = (ini_path + __script__ + '.ini')
    f = open(ini_file,'r')
    fData = f.read()
    f.close
  except:
    return

  cat_list = []
  wk = []
  wk_cat = []
  #split by \n and omit line that contain only (CR/LF)
  lnDatalist = [x for x in fData.split("\n") if len(x) > 1]

  for lnData in lnDatalist:
    lnDatawk = re.sub("[ \t]+"," ",lnData)
    lnDatawk = (re.sub("[\n\r]+","",lnDatawk)).strip()

    confData = lnDatawk.split(" ")
    if len(confData) < 2: continue # no confData[1] error
    if confData[0]   == "LS"  :          LS = int(confData[1])
    elif confData[0]   == "Jump_range":  Jump_range = int(confData[1])
    elif confData[0] == "pdb_file":      pdb_file = confData[1]
    elif confData[0] == "log_file":      log_file = confData[1]
    elif confData[0] == "Default_path":  Default_path = confData[1]
    elif confData[0] == "category":
      confData = lnDatawk.split(" ", 1)
      wk = confData[1].split(",")
      if len(wk) > 1: #exist wk[0],wk[1]
        wk_cat = [wk[0], wk[1]]
        cat_list.append(wk_cat)
  if not cat_list ==[]:
    category = cat_list
  if LS == 1: LS = 1 #force LS to 0 or 1,
  else:       LS = 0 # otherwise index error will occured


def set_typemarklist():
  """
  グローバル定義のキーワードを元に、各種のリストを作成する。
  """
  global type_list
  global mark_list
  global type_list_u
  global mark_list_u
  global type_list_p
  global mark_list_p
  global type_all
  global mark_all

  type_list   = [x[LS] for x in category if len(x) > 0]
  mark_list   = [item_ndone[LS],item_done[LS]]

  type_list_u = []
  mark_list_u = []

  for x in type_list:
    type_list_u.append(unicode(x))
  for x in mark_list:
    mark_list_u.append(unicode(x))

  type_list_p = type_list_u + [unicode(item_alltype[LS])]
  mark_list_p = mark_list_u + [unicode(item_allmark[LS])]

  type_all    = len(type_list)
  mark_all    = len(mark_list)


class Notepad:
  def __init__(self):
    self.lock = e32.Ao_lock()
    self.Msglist = []
    self.ss_word = 'None'
    self.sel_list = []
    self.index = 0
    self.MT_flg = ''
    self.page = 'None'
    self.next_id = 'None'
    self.example = msg_example[LS]
    self.first_flg = 1 #allow make appuifw.Listbox first time
    self.sel_list_bak = []


  def run(self):
    self.dbms = e32db.Dbms()
    self.ndb = e32db.Db_view()
    self.body = appuifw.Text()
    self.Gpath = Getpath()
    appuifw.app.body = self.body
    appuifw.app.menu = []
    self.ss_type = type_all
    self.ss_mark = mark_all
    old_title = appuifw.app.title
    if not os.path.exists(pdb_file):
        self.make_newfile()
    try:
        self.dbms.open(unicode(pdb_file))
    except:
        rtn = appuifw.query(unicode('Open Error \n pdb_file'),'query')
        return
    self.list_setup()
    self.refresh()
    self.lock.wait()
    ## all process is executed at this point
    self.dbms.compact()
    appuifw.app.title = old_title
    appuifw.app.body = None
    self.listbox = None
    self.dbms.close()


  def refresh(self, index2zero=None):
    if self.sel_list:
      self.paint('list')
      if self.first_flg == 1:
        self.first_flg = 0
        if appuifw2_exist == 1:
          self.listbox = appuifw2.Listbox(self.sel_list, self.selected)
        else:
          self.listbox = appuifw.Listbox(self.sel_list, self.selected)
        self.listbox.bind(EKeyLeftArrow, lambda: self.jump('b'))
        self.listbox.bind(EKeyRightArrow, lambda: self.jump('f'))
        appuifw.app.body = self.listbox
      else:
        appuifw.app.body = self.listbox
        #*1 back to 0 Listbox pointer (required by appuifw2)
        if index2zero and self.sel_list_bak:
          self.listbox.set_list(self.sel_list_bak, 0) #*1
        if self.index >= len(self.sel_list):   #*0013
          self.index = len(self.sel_list) - 1
        self.listbox.set_list(self.sel_list,self.index)
    else:
      self.paint('word')
      self.Msglist = [(msg_searchword[LS] + self.ss_word + '\n')]
      self.Msglist.append(msg_noword[LS])
      self.disp_result(self.Msglist)


  def cbbword(self):
    self.ss_word = str(appuifw.query(unicode(msg_inputword[LS]),'text', \
					unicode(self.example)))
    if self.ss_word != None:
      self.example = self.ss_word #search again to update list
    else:
      self.ss_word = 'None'
    self.go2newlist()


  def back2list(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    self.paint('list')
    self.refresh()


  def go2newlist(self):
    self.paint('list')
    #*1/*2: don't change this order
    #*1: required by appuifw2.Listbox
    if self.sel_list: #*1
      self.sel_list_bak = [x for x in self.sel_list] #*1
    self.list_setup() #*2
#    self.index = 0    #*0013
    self.refresh(index2zero=True)


  def list_update(self):
    """update list on the screen, don't change search/extract
       condition before call 'list_update'
    """
    self.paint('list')
    self.list_setup()
    #keep self_index: need when click item after purchase
    self.refresh()


  def alllist(self):
    self.ss_word = 'None'
    self.ss_type = type_all
    self.ss_mark = mark_all
    self.index = 0
    self.go2newlist()


  def about(self):
    msg = [('App Name : ' + __script__ + '\n'),
           ('Version : ' + __version__ + '\n'),
           ('Author : ' + __author__ + '\n' ),
           (__web__  + '\n'),
           (__Copyright__)]
    self.paint('about')
    self.disp_result(msg) # display screen again


  def jump(self, flg):
    i = self.listbox.current()
    i_max = len(self.sel_list) - 1
    if flg == 'f': # jump forward
      i = i + Jump_range
      if i > i_max : i = i_max
    else: # b jump backward
      i = i - Jump_range
      if i < 0 : i = 0
    self.listbox.set_list(self.sel_list, i)


  def view_log(self, Log):
    self.paint('about')
    self.disp_result(Log) # display screen again


  def exit1(self):
    self.lock.signal()


  def set_tm(self):
    appuifw.app.menu = []
    fld_id = 0 # dummy
    flg = 1 # 1:from Prepare_flg process
    Type = int(self.ss_type)
    Mark = int(self.ss_mark)
    msg, self.ss_type, self.ss_mark = self.get_typemark(fld_id, \
                                 menu_listtm[LS], Type, Mark, flg)
    if Type != self.ss_type or Mark != self.ss_mark:
      self.go2newlist()
    else:
      self.back2list()


  def edit_item(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    fld_id = self.db_id[self.index]
    fld_note,  fld_type, fld_mark = self.get_currentdata(fld_id)

    self.paint('about')

    msg_note, msg_type, msg_mark = self.get_typemark(fld_id, fld_note, \
                                                     fld_type, fld_mark, 0)
    if fld_type != msg_type or fld_mark != msg_mark or fld_note != msg_note : 
      msg_note = msg_note.replace("'","''")
      query = u'UPDATE Table1 SET Item = \'%s\', Type=%d, Mark=%d \
                WHERE Key = %d' % (msg_note, msg_type,msg_mark,fld_id)
      self.dbms.begin()
      rtn = self.dbms.execute(query)
      self.dbms.commit()
      self.go2newlist()
    else:
      self.back2list()


  def new_item(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    self.paint('about')
    if self.next_id == 'None':
      query = u"SELECT * FROM Table1"
      self.ndb.prepare(self.dbms,query )
      self.ndb.first_line()

      # get (max_id# +1) use it for next id#
      db_id = []
      if self.ndb.count_line() > 0:
          for k in range(self.ndb.count_line()):
            self.ndb.get_line()
            db_id.append(self.ndb.col(1))
            self.ndb.next_line()
          db_id.sort()
          self.next_id = db_id[-1] + 1
      else:
        self.next_id = 0

    self.paint('about')

    msg_note, msg_type, msg_mark = self.get_typemark(self.next_id, "")
    if msg_note != "" : 
      msg_note = msg_note.replace("'","''")
      query = u"INSERT INTO Table1 (Key, Item, Type, Mark) VALUES \
			(%d, '%s', %d, %d)" %(self.next_id, msg_note, msg_type, msg_mark)
      self.dbms.begin()
      rtn = self.dbms.execute(query)
      self.dbms.commit()
      self.next_id = self.next_id + 1
      self.go2newlist()
    else:
      self.back2list()


  def get_typemark(self,id, note, Type=0, Mark=1,flg=0):
    if flg == 0:
      typelist = type_list_u
      marklist = mark_list_u
    else:
      typelist = type_list_p
      marklist = mark_list_p

    form = appuifw.Form([(unicode(item_id[LS]),'number',id),
					(unicode(item_type[LS]),'combo',(typelist,Type)),
					(unicode(item_mark[LS]),'combo',(marklist,Mark)),
					(unicode(item_note[LS]),'text',unicode(note))],
			appuifw.FFormEditModeOnly)
    form.execute()
    msg_type = ((form[1])[2])[1]
    msg_mark = ((form[2])[2])[1]
    msg_note = ((form[3])[2]).encode('utf-8')

    return msg_note, msg_type, msg_mark


  def del_item(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    fld_id   = self.db_id[self.index]
    fld_note,  fld_type, fld_mark = self.get_currentdata(fld_id)

    msg = menu_delete[LS] + '\n  (' + fld_note + '..)'
    rtn = appuifw.query(unicode(msg),'query')
    if rtn == 1:
      query = u'DELETE FROM Table1 WHERE Key =%d' %(fld_id)
      self.dbms.begin()
      rtn = self.dbms.execute(query)
      self.dbms.commit()
      if self.index > 0 : self.index = (self.index - 1)
    self.go2newlist()


  def paint(self,flg='about'): # first paint screen
    appuifw.app.title = unicode(__script__ + self.MT_flg)
#    self.body = appuifw.Text()
#    appuifw.app.body = self.body
    self.page = flg

    if flg == 'list':
      appuifw.app.menu = [(unicode(menu_wordnext[LS]), self.cbbword),
					(unicode(menu_item[LS]),
						((unicode(menu_new[LS]), self.new_item),
						(unicode(menu_edittm[LS]), self.edit_item),
						(unicode(menu_delete[LS]), self.del_item),
						(unicode(menu_details[LS]), self.details))),
					(unicode(menu_list[LS]),
						((unicode(menu_listtm[LS]),self.set_tm),
						(unicode(menu_back2list[LS]),self.back2list),
						(unicode(menu_alllist[LS]), self.alllist))),
					(unicode(menu_file[LS]),
						((unicode(menu_import[LS]),self.csv_import),
						(unicode(menu_export[LS]),self.csv_export),
						(unicode(menu_compact[LS]), self.exec_compact))),
					(unicode(menu_about[LS]), self.about),
					(unicode(menu_exit[LS]), self.exit1)]
#      appuifw.app.exit_key_handler = lambda: self.back2list()
      appuifw.app.exit_key_handler = lambda: self.exit1()


    elif flg == 'word':
      appuifw.app.menu = [(unicode(menu_wordnext[LS]), self.cbbword),
					(unicode(menu_new[LS]), self.new_item),
					(unicode(menu_list[LS]),
						((unicode(menu_listtm[LS]),self.set_tm),
						(unicode(menu_back2list[LS]),self.back2list),
						(unicode(menu_alllist[LS]), self.alllist))),
					(unicode(menu_file[LS]),
						((unicode(menu_import[LS]),self.csv_import),
						(unicode(menu_export[LS]),self.csv_export))),
					(unicode(menu_exit[LS]), self.exit1)]
      appuifw.app.exit_key_handler = lambda: self.back2list()

    else: ## 'about' and others
      appuifw.app.menu = [(unicode(menu_back2list[LS]), self.back2list)]
      appuifw.app.exit_key_handler = lambda: self.back2list()


  def disp_result(self,msglist):  # dispaly search result
    self.body.clear()
    appuifw.app.body = self.body
    self.body.font = 'dense'   # small
    self.body.color = 0x000000
    for i in range(len(msglist)):
        self.body.add(unicode((str(msglist[i])),'utf-8'))
#    self.body.set_pos(0) #  move cursol to top
    e32.ao_sleep(0.001,) # screen redrow


  def list_setup(self):
    self.db_id   = []
    self.sel_list = []
    wk_dbid = [[]]
    wk_sellist = [[]]

    # ソートのために空のリストのリストを作成する。
    # カテゴリの数（type_allの数値）が分かっていれば[[],[],..[]]でもよい。
    for x in range(type_all):
      wk_dbid.append('')
      wk_sellist.append('')
    for x in range(type_all):
      wk_dbid[x] = []
      wk_sellist[x] = []

    appuifw.app.menu = []
#    self.disp_result([msg_inprocess[LS]])

    if self.ss_type == type_all and self.ss_mark == mark_all and \
					self.ss_word == 'None':
      self.MT_flg = ""
    else:
      self.MT_flg = "#"

    query = u'SELECT * FROM Table1 ORDER BY Item ASC'
    self.ndb.prepare(self.dbms,query )
    self.ndb.first_line()

    for k in range(self.ndb.count_line()):
      self.ndb.get_line()
      sflg0 = sflg1 = sflg2 = 1

      if self.ss_word != 'None':
        if re.search(unicode(self.ss_word),self.ndb.col(2), re.I) == None : sflg0 = 0
      if self.ss_type != type_all:
        if self.ss_type != self.ndb.col(3) : sflg1 = 0
      if self.ss_mark != mark_all:
        if self.ss_mark != self.ndb.col(4):sflg2 = 0

      #sort by Type (Item is already sorted by dbms query)
      if sflg0 * sflg1 * sflg2 == 1:
        type_nr = (self.ndb.col(3))
        wk_dbid[type_nr].append(self.ndb.col(1))
        wk_sellist[type_nr].append((type_list[(self.ndb.col(3))])[0:2] + ' ' + \
			'[' + (mark_list[(self.ndb.col(4))])[0:1] + ']' + ' ' +\
			 self.ndb.col(2)[:14])
      self.ndb.next_line()

    # make list from [list of list]
    for x in range(type_all):
      if wk_dbid[x] != []:
        self.db_id = self.db_id + wk_dbid[x]
        self.sel_list = self.sel_list + wk_sellist[x]

    if len(self.db_id) == 0: ##  Search result not exist
      self.sel_list = [] #when sel_list is empty,disp 'empty' in refresh


  def selected(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    fld_id = self.db_id[self.index]
    fld_note,  fld_type, fld_mark = self.get_currentdata(fld_id)

    self.paint('about')

    if fld_mark == 0:  msg_mark = 1
    else            :  msg_mark = 0
    msg = fld_note.replace("'","''")
    query = u'UPDATE Table1 SET Item = \'%s\', Type=%d, Mark=%d \
				WHERE Key = %d' % (msg, fld_type, msg_mark, fld_id)
    self.dbms.begin()
    rtn = self.dbms.execute(query)
    self.dbms.commit()
    self.list_update()


  def details(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    fld_id   = self.db_id[self.index]
    fld_note,  fld_type, fld_mark = self.get_currentdata(fld_id)


    self.Msglist = [('ID#: ' + str(fld_id) + '\n' \
				 + type_list[(fld_type)] + '\n' + \
				mark_list[(fld_mark)] + '\n' + fld_note)]
    self.paint('about')
    self.disp_result(self.Msglist)


  def exec_compact(self):
    self.disp_result([msg_inprocess[LS]]) # display "in process"
    self.dbms.compact()
    self.dbms.close()
    self.dbms.open(unicode(pdb_file))
    self.back2list()


  def get_currentdata(self,fld_id):
    id = fld_id
    query = u"SELECT * FROM Table1 WHERE Key=%d" %(id)
    self.ndb.prepare(self.dbms,query )
    self.ndb.first_line()
    self.ndb.get_line()
    # return Item, Type, Mark
    return self.ndb.col(2), self.ndb.col(3), self.ndb.col(4)


  def make_newfile(self):
    """
    file not exist ,make new file
    """
    appuifw.note(unicode(msg_nofile[LS]+msg_makefile[LS]),'info')
    self.dbms.create(unicode(pdb_file))
    self.dbms.open(unicode(pdb_file))

    query = u'CREATE TABLE Table1 (Key INTEGER, Item VARCHAR, \
					Type INTEGER, Mark INTEGER)'
    rtn = self.dbms.execute(query)
    self.dbms.close()


  def csv_import(self):
    """
    import Item data from csv file (not merge, all data replaced)
    """
    # get file path to read
    csv_file = self.Gpath.get_read_path(title=msg_select[LS], \
                       default_path = Default_path)

    if csv_file == None or not os.path.isfile(csv_file):
      self.back2list()
    else:
      rtn = appuifw.query(unicode(msg_convert[LS]),'query')
      if not rtn:
          self.back2list()
      else:
          # import
          db_item = []
          db_type = []
          db_mark = []
          Log = ''

          self.disp_result([msg_inprocess[LS]])

          try:
            f = open(csv_file, 'r')
            try:
              fData = f.read()
            finally:
              f.close()
          except:
            rtn = appuifw.query(unicode(msg_ioerror[LS]),'query')
            return

          fLines = fData.split('\n')

          cnt = 0 #line counter
          for line in fLines:
            cnt = cnt + 1
            if len(line.strip()) == 0:continue #may be last line(only LF)

            line = re.sub("[\n\r]+","",line)
            iData = line.split(',')
            if len(iData) > 3:
              # Type
              if len(iData[1]) != 0:
                try:
                  x = int(iData[1])
                  if x < type_all:
                    db_type.append(x) # exist data and < type_all
                  else: # too big data value
                    Log = Log + 'line ' + str(cnt) + ' Type value error\n'
                except:
                  Log = Log + 'line ' + str(cnt) + ' Type value error\n'
              else: # no data
                Log = Log + 'line ' + str(cnt) + ' no Type data error\n'

            # Mark
              if len(iData[2]) != 0:
                try:
                  x = int(iData[2])
                  if x < mark_all:
                    db_mark.append(x) # exist data and < type_mark
                  else:
                    Log = Log + 'line ' + str(cnt) + ' Mark value error\n'
                except:
                  Log = Log + 'line ' + str(cnt) + ' Mark value error\n'
              else:
                db_mark.append(int('1')) # set done

              # Item
              if len(iData[3]) != 0:
                db_item.append(iData[3])
              else:
                Log = Log + 'line ' + str(cnt) + ' Item data empty error\n'
            else: # 
              Log = Log + 'line ' + str(cnt) + ' wrong data\n'

          # some error detecred in csv_file
          if Log:
            try :
              f = open(log_file, 'w')
              try:
                f.write(Log)
              finally:
                f.close()
            except:
              pass
            # disp error message
            rtn = appuifw.query(unicode(msg_csverror[LS]),'query') 
            msg = Log.split("\n")[0:20]
            msg = [x+"\n" for x in msg]
            msg.append("...")
            self.view_log(msg)

          else: # no error
            # delete all data in pdb file
            query = u'DELETE FROM Table1 WHERE Key <%d' %(int(1000)) #*001_2
            self.dbms.begin()
            rtn = self.dbms.execute(query)
            self.dbms.commit()
            self.index = 0

            # output to empty (pdb) file
            cnt = 0 # for dispaly
            db_item_len = len(db_item)
            for k in range(db_item_len):
              fld_type = db_type[k]
              fld_mark = db_mark[k]
              fld_item = (db_item[k]).replace("'", "''")

              query = u'INSERT INTO Table1 (Key, Item,Type,Mark) VALUES \
                   (%d, \'%s\', %d, %d)' %(k, fld_item, fld_type, fld_mark)
#              self.dbms.begin()
              rtn = self.dbms.execute(query)
#              self.dbms.commit()

              if (cnt % 5) == 0:
                self.disp_result([ msg_inprocess[LS] + '*** %d / %d ***' % \
                                                        (cnt, db_item_len)])
              cnt = cnt + 1
            self.alllist()

  # end of convert


  def csv_export(self):
    """
    export "selected data" (they are display on the screen) to csv file
    """
    #get file path to write
    out_file = self.Gpath.get_write_path(title=msg_filename[LS], \
                     default_path=Default_path, \
                     msg_ow=msg_overwr[LS], msg_fn=msg_filename[LS], \
                     msg_ex=msg_exfile[LS])

    if out_file != None:
      #display "export in process"
      self.disp_result([msg_inprocess[LS]], )

      #Make categry_table
      cat_table = [(x.split(":")[1]).strip() for x in type_list]

      #convert selected data to csv format
      csv_dt = ''
      for id in self.db_id:
        query = u"SELECT * FROM Table1 WHERE Key=%d" %(id)
        self.ndb.prepare(self.dbms,query )
        self.ndb.first_line()
        self.ndb.get_line()
        Item, Type, Mark,  = self.ndb.col(2), self.ndb.col(3), self.ndb.col(4)
        csv_dt = csv_dt + cat_table[Type] +","+ str(Type)+","+ str(Mark) +","+Item+"\n"

      try:
        f = open(out_file,'w')
        try:
          f.write(csv_dt)
        finally:
          f.close()
      except:
        rtn = appuifw.query(unicode(msg_ioerror[LS]),'query')

    self.back2list()
# end of convet


if __name__ == '__main__':
    if Err_exit == 0:
        confread()          #don't change order of this 2 proc
        set_typemarklist()  #
        Np = Notepad()
        Np.run()
#  appuifw.app.set_exit()
#  sys.exit()
